Subject: Re: [PATCH] tipc: checking returns and Re: Possible Circular Locking in TIPC

From: Jarek Poplawski <[email-masked]>
Date: Fri, 5 Jan 2007 08:58:57 +0100

On Thu, Jan 04, 2007 at 04:16:20PM +0000, Jon Maloy wrote:
> Regards
> ///jon
> 
> Jarek Poplawski wrote:
> 
> >
> >I know lockdep is sometimes
> >too careful but nevertheless some change is needed
> >to fix a real bug or give additional information
> >to lockdep. 
> > 
> >
> I don't know lockdep well enough yet, but I will try to find out if that
> is possible.

If you are sure there is no circular locking possible
between these two functions and this entry->lock here
isn't endangered by other functions, you could try to
make lockdep "silent" like this: 

        write_lock_bh(&ref_table_lock);
        if (tipc_ref_table.first_free) {
                index = tipc_ref_table.first_free;
                entry = &(tipc_ref_table.entries[index]);
                index_mask = tipc_ref_table.index_mask;
                /* take lock in case a previous user of entry still holds it */

-                spin_lock_bh(&entry->lock, );
+		local_bh_disable();
+		spin_lock_nested(&entry->lock, SINGLE_DEPTH_NESTING);

                next_plus_upper = entry->data.next_plus_upper;
                tipc_ref_table.first_free = next_plus_upper & index_mask;
                reference = (next_plus_upper & ~index_mask) + index;
                entry->data.reference = reference;
                entry->object = object;
                if (lock != 0)
                        *lock = &entry->lock;

/* may stay as is or: */
-                spin_unlock_bh(&entry->lock);
+		spin_unlock(&entry->lock);
+		local_bh_enable();

        }
        write_unlock_bh(&ref_table_lock);

Cheers,
Jarek P.